require 'utils_drawer/table_drawer/table'
require 'utils_drawer/table_drawer/row'
require 'utils_drawer/table_drawer/column_validator'
require 'utils_drawer/table_drawer/column'

require 'utils_drawer/graph_drawer/graph.rb'
require 'utils_drawer/graph_drawer/data.rb'

module UtilsDrawer
  def table(min_column_size = 10)
    @table = TableDrawer::Table.new(min_column_size)
    yield
    @table.to_s
  end

  def row
    @row = TableDrawer::Row.new
    yield
    @table.add(@row)
  end

  def column(text, size = nil)
    @column = TableDrawer::Column.new(text, size)
    @row.add(@column)
  end

  def graph(option = { omission: true })
    @graph = GraphDrawer::Graph.new(option)
    yield
    @graph.datas_init
    @graph.to_s
  end

  def data(item, value)
    @data = GraphDrawer::Data.new(item, value)
    @graph.add(@data)
  end
end
