require 'safe_colorize'

module UtilsDrawer
  module GraphDrawer
    class Data
      using SafeColorize

      attr_accessor :item
      attr_accessor :value
      attr_accessor :level

      def initialize(item, value)
        @item = item
        @value = value
        @level = nil
      end

      def to_s
        color =
          case @level
          when 1
            :green
          when 2
            :cyan
          when 3
            :blue
          end

        if @value.zero?
          draw_str = "#{@item}|"
        else
          bar = ' ' * (@value - @value.to_s.size)
          data_label = @value.to_s.color(:black)
          draw_str = "#{@item}|#{(bar + data_label).bg_color(color)}"
        end

        draw_str
      end
    end
  end
end
